diff --git a/web/pgadmin/browser/static/js/browser.js b/web/pgadmin/browser/static/js/browser.js
index 4aa5b8ba..3dac0cb6 100644
--- a/web/pgadmin/browser/static/js/browser.js
+++ b/web/pgadmin/browser/static/js/browser.js
@@ -783,243 +756,243 @@ define(
 
     onAddTreeNode: function(_data, _hierarchy, _opts) {
       var ctx = {
-            b: this, // Browser
-            d: null, // current parent
-            hasId: true,
-            i: null, // current item
-            p: _.toArray(_hierarchy || {}).sort(
-              function(a, b) {
-                return (a.priority === b.priority) ? 0 : (
-                  a.priority < b.priority ? -1 : 1
-                );
-              }
-            ), // path of the parent
-            pI: [], // path Item
-            t: this.tree, // Tree Api
-            o: _opts
-          },
-          traversePath = function() {
-            var ctx = this, i, d;
-
-            ctx.success = traversePath;
-            if (ctx.p.length) {
-              d = ctx.p.shift();
-              // This is the parent node.
-              // Replace the parent-id of the data, which could be different
-              // from the given hierarchy.
-              if (!ctx.p.length) {
-                d._id = _data._pid;
-                ctx.success = addItemNode;
-              }
-              ctx.b._findTreeChildNode(
-                ctx.i, d, ctx
-              );
-              // if parent node is null
-              if (!_data._pid) {
-                addItemNode.apply(ctx, arguments);
-              }
+          b: this, // Browser
+          d: null, // current parent
+          hasId: true,
+          i: null, // current item
+          p: _.toArray(_hierarchy || {}).sort(
+          function(a, b) {
+            return (a.priority === b.priority) ? 0 : (
+              a.priority < b.priority ? -1 : 1
+            );
+          }
+        ), // path of the parent
+          pathOfTreeItems: [], // path Item
+          t: this.tree, // Tree Api
+          o: _opts,
+        },
+        traversePath = function() {
+          var ctx = this, data;
+
+          ctx.success = traversePath;
+          if (ctx.p.length) {
+            data = ctx.p.shift();
+            // This is the parent node.
+            // Replace the parent-id of the data, which could be different
+            // from the given hierarchy.
+            if (!ctx.p.length) {
+              data._id = _data._pid;
+              ctx.success = addItemNode;
             }
-            return true;
-          }.bind(ctx),
-          addItemNode = function() {
-            // Append the new data in the tree under the current item.
-            // We may need to pass it to proper collection node.
-            var ctx = this,
-                first = (ctx.i || this.t.wasLoad(ctx.i)) &&
-                  this.t.first(ctx.i),
-                findChildNode = function(success, notFound) {
-                  var ctx = this;
-                  ctx.success = success;
-                  ctx.notFound = notFound;
-
-                  ctx.b._findTreeChildNode(ctx.i, _data, ctx);
-                }.bind(ctx),
-                selectNode = function() {
-                  this.t.openPath(this.i);
-                  this.t.select(this.i);
-                  if (
-                    ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
-                  ) {
-                    ctx.o.success.apply(ctx.t, [ctx.i, _data]);
+            ctx.b._findTreeChildNode(
+              ctx.i, data, ctx
+            );
+            // if parent node is null
+            if (!_data._pid) {
+              addItemNode.apply(ctx, arguments);
+            }
+          }
+          return true;
+        }.bind(ctx),
+        addItemNode = function() {
+          // Append the new data in the tree under the current item.
+          // We may need to pass it to proper collection node.
+          var ctx = this,
+            first = (ctx.i || this.t.wasLoad(ctx.i)) &&
+            this.t.first(ctx.i),
+            findChildNode = function(success, notFound) {
+              var ctx = this;
+              ctx.success = success;
+              ctx.notFound = notFound;
+
+              ctx.b._findTreeChildNode(ctx.i, _data, ctx);
+            }.bind(ctx),
+            selectNode = function() {
+              this.t.openPath(this.i);
+              this.t.select(this.i);
+              if (
+                ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
+              ) {
+                ctx.o.success.apply(ctx.t, [ctx.i, _data]);
+              }
+            }.bind(ctx),
+            addNode = function() {
+              var ctx = this,
+                items = ctx.t.children(ctx.i),
+                s = 0, e = items.length - 1, i,
+                linearSearch = function() {
+                  while (e >= s) {
+                    i = items.eq(s);
+                    var d = ctx.t.itemData(i);
+                    if (
+                      pgAdmin.natural_sort(
+                        d._label, _data._label
+                      ) == 1
+                    )
+                      return true;
+                    s++;
                   }
-                }.bind(ctx),
-                addNode = function() {
-                  var ctx = this,
-                      items = ctx.t.children(ctx.i),
-                      s = 0, e = items.length - 1, i,
-                      linearSearch = function() {
-                        while (e >= s) {
-                          i = items.eq(s);
-                          var d = ctx.t.itemData(i);
-                          if (
-                            pgAdmin.natural_sort(
-                              d._label, _data._label
-                            ) == 1
-                          )
-                            return true;
-                          s++;
-                        }
-                        if (e != items.length - 1) {
-                          i = items.eq(e);
-                          return true;
-                        }
-                        i = null;
-                        return false;
-                      },
-                      binarySearch = function() {
-                        var d, m;
-                        // Binary search only outperforms Linear search for n > 44.
-                        // Reference:
-                        // https://en.wikipedia.org/wiki/Binary_search_algorithm#cite_note-30
-                        //
-                        // We will try until it's half.
-                        while (e - s > 22) {
-                          i = items.eq(s);
-                          var d = ctx.t.itemData(i);
-                          if (
-                            pgAdmin.natural_sort(
-                              d._label, _data._label
-                            ) != -1
-                          )
-                            return true;
-                          i = items.eq(e);
-                          d = ctx.t.itemData(i);
-                          if (
-                            pgAdmin.natural_sort(
-                              d._label, _data._label
-                            ) != 1
-                          )
-                            return true;
-                          var m = s + Math.round((e - s) / 2);
-                          i = items.eq(m);
-                          d = ctx.t.itemData(i);
-                          var res = pgAdmin.natural_sort(d._label, _data._label);
-                          if (res == 0)
-                            return true;
-
-                          if (res == -1) {
-                            s = m + 1;
-                            e--;
-                          } else {
-                            s++;
-                            e = m - 1;
-                          }
-                        }
-                        return linearSearch();
-                      };
-
-                  if (binarySearch()) {
-                    ctx.t.before(i, {
-                      itemData: _data,
-                      success: function() {
-                        if (
-                          ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
-                        ) {
-                          ctx.o.success.apply(ctx.t, [i, _data]);
-                        }
-                      },
-                      fail: function() {
-                        console.log('Failed to add before..');
-                        if (
-                          ctx.o && ctx.o.fail && typeof(ctx.o.fail) == 'function'
-                        ) {
-                          ctx.o.fail.apply(ctx.t, [i, _data]);
-                        }
-                      }
-                    });
-                  } else {
-                    var _append = function() {
-                          var ctx = this,
-                            is_parent_loaded_before = ctx.t.wasLoad(ctx.i),
-                            _parent_data = ctx.t.itemData(ctx.i);
-
-                          ctx.t.append(ctx.i, {
-                            itemData: _data,
-                            success: function(item, options) {
-                              var i = $(options.items[0]);
-                              // Open the item path only if its parent is loaded
-                              // or parent type is same as nodes
-                              if(
-                                is_parent_loaded_before &&
-                                _parent_data &&  _parent_data._type.search(
-                                  _data._type
-                                ) > -1
-                              ) {
-                                ctx.t.openPath(i);
-                                ctx.t.select(i);
-                              } else {
-                                if (_parent_data) {
-                                  // Unload the parent node so that we'll get
-                                  // latest data when we try to expand it
-                                  ctx.t.unload(ctx.i, {
-                                    success: function (item, options) {
-                                      // Lets try to load it now
-                                      ctx.t.open(item);
-                                    }
-                                  });
-                                }
-                              }
-                              if (
-                                ctx.o && ctx.o.success &&
-                                typeof(ctx.o.success) == 'function'
-                              ) {
-                                ctx.o.success.apply(ctx.t, [i, _data]);
-                              }
-                            },
-                            fail: function() {
-                              console.log('Failed to append');
-                              if (
-                                ctx.o && ctx.o.fail &&
-                                typeof(ctx.o.fail) == 'function'
-                              ) {
-                                ctx.o.fail.apply(ctx.t, [ctx.i, _data]);
-                              }
-                            }
-                          });
-                        }.bind(ctx);
-
-                    if (ctx.i && !ctx.t.isInode(ctx.i)) {
-                        ctx.t.setInode(ctx.i, {success: _append});
+                  if (e != items.length - 1) {
+                    i = items.eq(e);
+                    return true;
+                  }
+                  i = null;
+                  return false;
+                },
+                binarySearch = function() {
+                  var d, m, res;
+                  // Binary search only outperforms Linear search for n > 44.
+                  // Reference:
+                  // https://en.wikipedia.org/wiki/Binary_search_algorithm#cite_note-30
+                  //
+                  // We will try until it's half.
+                  while (e - s > 22) {
+                    i = items.eq(s);
+                    d = ctx.t.itemData(i);
+                    if (
+                      pgAdmin.natural_sort(
+                        d._label, _data._label
+                      ) != -1
+                    )
+                      return true;
+                    i = items.eq(e);
+                    d = ctx.t.itemData(i);
+                    if (
+                      pgAdmin.natural_sort(
+                        d._label, _data._label
+                      ) != 1
+                    )
+                      return true;
+                    m = s + Math.round((e - s) / 2);
+                    i = items.eq(m);
+                    d = ctx.t.itemData(i);
+                    res = pgAdmin.natural_sort(d._label, _data._label);
+                    if (res == 0)
+                      return true;
+
+                    if (res == -1) {
+                      s = m + 1;
+                      e--;
                     } else {
-                        // Handle case for node without parent i.e. server-group
-                        // or if parent node's inode is true.
-                        _append();
+                      s++;
+                      e = m - 1;
                     }
                   }
-                }.bind(ctx);
+                  return linearSearch();
+                };
 
-            // Parent node do not have any children, let me unload it.
-            if (!first && ctx.t.wasLoad(ctx.i)) {
-              ctx.t.unload(ctx.i, {
-                success: function() {
-                  findChildNode(
-                    selectNode,
-                    function() {
-                      var o = this && this.o;
+              if (binarySearch()) {
+                ctx.t.before(i, {
+                  itemData: _data,
+                  success: function() {
+                    if (
+                      ctx.o && ctx.o.success && typeof(ctx.o.success) == 'function'
+                    ) {
+                      ctx.o.success.apply(ctx.t, [i, _data]);
+                    }
+                  },
+                  fail: function() {
+                    console.warn('Failed to add before...', arguments);
+                    if (
+                      ctx.o && ctx.o.fail && typeof(ctx.o.fail) == 'function'
+                    ) {
+                      ctx.o.fail.apply(ctx.t, [i, _data]);
+                    }
+                  },
+                });
+              } else {
+                var _append = function() {
+                  var ctx = this,
+                    is_parent_loaded_before = ctx.t.wasLoad(ctx.i),
+                    _parent_data = ctx.t.itemData(ctx.i);
+
+                  ctx.t.append(ctx.i, {
+                    itemData: _data,
+                    success: function(item, options) {
+                      var i = $(options.items[0]);
+                      // Open the item path only if its parent is loaded
+                      // or parent type is same as nodes
+                      if(
+                        is_parent_loaded_before &&
+                          _parent_data &&  _parent_data._type.search(
+                            _data._type
+                          ) > -1
+                      ) {
+                        ctx.t.openPath(i);
+                        ctx.t.select(i);
+                      } else {
+                        if (_parent_data) {
+                          // Unload the parent node so that we'll get
+                          // latest data when we try to expand it
+                          ctx.t.unload(ctx.i, {
+                            success: function (item) {
+                              // Lets try to load it now
+                              ctx.t.open(item);
+                            },
+                          });
+                        }
+                      }
                       if (
-                        o && o.fail && typeof(o.fail) == 'function'
+                        ctx.o && ctx.o.success &&
+                          typeof(ctx.o.success) == 'function'
                       ) {
-                        o.fail.apply(this.t, [this.i, _data]);
+                        ctx.o.success.apply(ctx.t, [i, _data]);
                       }
-                    }.bind(this)
-                  );
-                }.bind(this),
-                fail: function() {
-                  var o = this && this.o;
-                  if (
-                    o && o.fail && typeof(o.fail) == 'function'
-                  ) {
-                    o.fail.apply(this.t, [this.i, _data]);
-                  }
-                }.bind(this)
-              });
-              return;
-            }
+                    },
+                    fail: function() {
+                      console.warn('Failed to append...', arguments);
+                      if (
+                        ctx.o && ctx.o.fail &&
+                          typeof(ctx.o.fail) == 'function'
+                      ) {
+                        ctx.o.fail.apply(ctx.t, [ctx.i, _data]);
+                      }
+                    },
+                  });
+                }.bind(ctx);
 
-            // We can find the collection node using _findTreeChildNode
-            // indirectly.
-            findChildNode(selectNode, addNode);
-          }.bind(ctx);
+                if (ctx.i && !ctx.t.isInode(ctx.i)) {
+                  ctx.t.setInode(ctx.i, {success: _append});
+                } else {
+                  // Handle case for node without parent i.e. server-group
+                  // or if parent node's inode is true.
+                  _append();
+                }
+              }
+            }.bind(ctx);
+
+          // Parent node do not have any children, let me unload it.
+          if (!first && ctx.t.wasLoad(ctx.i)) {
+            ctx.t.unload(ctx.i, {
+              success: function() {
+                findChildNode(
+                  selectNode,
+                  function() {
+                    var o = this && this.o;
+                    if (
+                      o && o.fail && typeof(o.fail) == 'function'
+                    ) {
+                      o.fail.apply(this.t, [this.i, _data]);
+                    }
+                  }.bind(this)
+                );
+              }.bind(this),
+              fail: function() {
+                var o = this && this.o;
+                if (
+                  o && o.fail && typeof(o.fail) == 'function'
+                ) {
+                  o.fail.apply(this.t, [this.i, _data]);
+                }
+              }.bind(this),
+            });
+            return;
+          }
+
+          // We can find the collection node using _findTreeChildNode
+          // indirectly.
+          findChildNode(selectNode, addNode);
+        }.bind(ctx);
 
       if (!ctx.t.wasInit() || !_data) {
         return;
